diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/tcp/tcp-bbr-example.cc ns-3.34/examples/tcp/tcp-bbr-example.cc
--- ns-3.33/examples/tcp/tcp-bbr-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/examples/tcp/tcp-bbr-example.cc	2021-07-14 10:31:06.000000000 -0700
@@ -0,0 +1,259 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018-20 NITK Surathkal
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Aarti Nandagiri <aarti.nandagiri@gmail.com>
+ *          Vivek Jain <jain.vivek.anand@gmail.com>
+ *          Mohit P. Tahiliani <tahiliani@nitk.edu.in>
+ */
+
+// This program simulates the following topology:
+//
+//           1000 Mbps           10Mbps          1000 Mbps
+//  Sender -------------- R1 -------------- R2 -------------- Receiver
+//              5ms               10ms               5ms
+//
+// The link between R1 and R2 is a bottleneck link with 10 Mbps. All other
+// links are 1000 Mbps.
+//
+// This program runs by default for 100 seconds and creates a new directory
+// called 'bbr-results' in the ns-3 root directory. The program creates one
+// sub-directory called 'pcap' in 'bbr-results' directory (if pcap generation
+// is enabled) and three .dat files.
+//
+// (1) 'pcap' sub-directory contains six PCAP files:
+//     * bbr-0-0.pcap for the interface on Sender
+//     * bbr-1-0.pcap for the interface on Receiver
+//     * bbr-2-0.pcap for the first interface on R1
+//     * bbr-2-1.pcap for the second interface on R1
+//     * bbr-3-0.pcap for the first interface on R2
+//     * bbr-3-1.pcap for the second interface on R2
+// (2) cwnd.dat file contains congestion window trace for the sender node
+// (3) throughput.dat file contains sender side throughput trace
+// (4) queueSize.dat file contains queue length trace from the bottleneck link
+//
+// BBR algorithm enters PROBE_RTT phase in every 10 seconds. The congestion
+// window is fixed to 4 segments in this phase with a goal to achieve a better
+// estimate of minimum RTT (because queue at the bottleneck link tends to drain
+// when the congestion window is reduced to 4 segments).
+//
+// The congestion window and queue occupancy traces output by this program show
+// periodic drops every 10 seconds when BBR algorithm is in PROBE_RTT phase.
+
+#include "ns3/core-module.h"
+#include "ns3/network-module.h"
+#include "ns3/internet-module.h"
+#include "ns3/point-to-point-module.h"
+#include "ns3/applications-module.h"
+#include "ns3/traffic-control-module.h"
+#include "ns3/flow-monitor-module.h"
+
+using namespace ns3;
+
+std::string dir;
+uint32_t prev = 0;
+Time prevTime = Seconds (0);
+
+// Calculate throughput
+static void
+TraceThroughput (Ptr<FlowMonitor> monitor)
+{
+  FlowMonitor::FlowStatsContainer stats = monitor->GetFlowStats ();
+  auto itr = stats.begin ();
+  Time curTime = Now ();
+  std::ofstream thr (dir + "/throughput.dat", std::ios::out | std::ios::app);
+  thr <<  curTime << " " << 8 * (itr->second.txBytes - prev) / (1000 * 1000 * (curTime.GetSeconds () - prevTime.GetSeconds ())) << std::endl;
+  prevTime = curTime;
+  prev = itr->second.txBytes;
+  Simulator::Schedule (Seconds (0.2), &TraceThroughput, monitor);
+}
+
+// Check the queue size
+void CheckQueueSize (Ptr<QueueDisc> qd)
+{
+  uint32_t qsize = qd->GetCurrentSize ().GetValue ();
+  Simulator::Schedule (Seconds (0.2), &CheckQueueSize, qd);
+  std::ofstream q (dir + "/queueSize.dat", std::ios::out | std::ios::app);
+  q << Simulator::Now ().GetSeconds () << " " << qsize << std::endl;
+  q.close ();
+}
+
+// Trace congestion window
+static void CwndTracer (Ptr<OutputStreamWrapper> stream, uint32_t oldval, uint32_t newval)
+{
+  *stream->GetStream () << Simulator::Now ().GetSeconds () << " " << newval / 1448.0 << std::endl;
+}
+
+void TraceCwnd (uint32_t nodeId, uint32_t socketId)
+{
+  AsciiTraceHelper ascii;
+  Ptr<OutputStreamWrapper> stream = ascii.CreateFileStream (dir + "/cwnd.dat");
+  Config::ConnectWithoutContext ("/NodeList/" + std::to_string (nodeId) + "/$ns3::TcpL4Protocol/SocketList/" + std::to_string (socketId) + "/CongestionWindow", MakeBoundCallback (&CwndTracer, stream));
+}
+
+int main (int argc, char *argv [])
+{
+  // Naming the output directory using local system time
+  time_t rawtime;
+  struct tm * timeinfo;
+  char buffer [80];
+  time (&rawtime);
+  timeinfo = localtime (&rawtime);
+  strftime (buffer, sizeof (buffer), "%d-%m-%Y-%I-%M-%S", timeinfo);
+  std::string currentTime (buffer);
+
+  std::string tcpTypeId = "TcpBbr";
+  std::string queueDisc = "FifoQueueDisc";
+  uint32_t delAckCount = 2;
+  bool bql = true;
+  bool enablePcap = false;
+  Time stopTime = Seconds (100);
+
+  CommandLine cmd (__FILE__);
+  cmd.AddValue ("tcpTypeId", "Transport protocol to use: TcpNewReno, TcpBbr", tcpTypeId);
+  cmd.AddValue ("delAckCount", "Delayed ACK count", delAckCount);
+  cmd.AddValue ("enablePcap", "Enable/Disable pcap file generation", enablePcap);
+  cmd.AddValue ("stopTime", "Stop time for applications / simulation time will be stopTime + 1", stopTime);
+  cmd.Parse (argc, argv);
+
+  queueDisc = std::string ("ns3::") + queueDisc;
+
+  Config::SetDefault ("ns3::TcpL4Protocol::SocketType", StringValue ("ns3::" + tcpTypeId));
+  Config::SetDefault ("ns3::TcpSocket::SndBufSize", UintegerValue (4194304));
+  Config::SetDefault ("ns3::TcpSocket::RcvBufSize", UintegerValue (6291456));
+  Config::SetDefault ("ns3::TcpSocket::InitialCwnd", UintegerValue (10));
+  Config::SetDefault ("ns3::TcpSocket::DelAckCount", UintegerValue (delAckCount));
+  Config::SetDefault ("ns3::TcpSocket::SegmentSize", UintegerValue (1448));
+  Config::SetDefault ("ns3::DropTailQueue<Packet>::MaxSize", QueueSizeValue (QueueSize ("1p")));
+  Config::SetDefault (queueDisc + "::MaxSize", QueueSizeValue (QueueSize ("100p")));
+
+  NodeContainer sender, receiver;
+  NodeContainer routers;
+  sender.Create (1);
+  receiver.Create (1);
+  routers.Create (2);
+
+  // Create the point-to-point link helpers
+  PointToPointHelper bottleneckLink;
+  bottleneckLink.SetDeviceAttribute  ("DataRate", StringValue ("10Mbps"));
+  bottleneckLink.SetChannelAttribute ("Delay", StringValue ("10ms"));
+
+  PointToPointHelper edgeLink;
+  edgeLink.SetDeviceAttribute  ("DataRate", StringValue ("1000Mbps"));
+  edgeLink.SetChannelAttribute ("Delay", StringValue ("5ms"));
+
+  // Create NetDevice containers
+  NetDeviceContainer senderEdge = edgeLink.Install (sender.Get (0), routers.Get (0));
+  NetDeviceContainer r1r2 = bottleneckLink.Install (routers.Get (0), routers.Get (1));
+  NetDeviceContainer receiverEdge = edgeLink.Install (routers.Get (1), receiver.Get (0));
+
+  // Install Stack
+  InternetStackHelper internet;
+  internet.Install (sender);
+  internet.Install (receiver);
+  internet.Install (routers);
+
+  // Configure the root queue discipline
+  TrafficControlHelper tch;
+  tch.SetRootQueueDisc (queueDisc);
+
+  if (bql)
+    {
+      tch.SetQueueLimits ("ns3::DynamicQueueLimits", "HoldTime", StringValue ("1000ms"));
+    }
+
+  tch.Install (senderEdge);
+  tch.Install (receiverEdge);
+
+  // Assign IP addresses
+  Ipv4AddressHelper ipv4;
+  ipv4.SetBase ("10.0.0.0", "255.255.255.0");
+
+  Ipv4InterfaceContainer i1i2 = ipv4.Assign (r1r2);
+
+  ipv4.NewNetwork ();
+  Ipv4InterfaceContainer is1 = ipv4.Assign (senderEdge);
+
+  ipv4.NewNetwork ();
+  Ipv4InterfaceContainer ir1 = ipv4.Assign (receiverEdge);
+
+  // Populate routing tables
+  Ipv4GlobalRoutingHelper::PopulateRoutingTables ();
+
+  // Select sender side port
+  uint16_t port = 50001;
+
+  // Install application on the sender
+  BulkSendHelper source ("ns3::TcpSocketFactory", InetSocketAddress (ir1.GetAddress (1), port));
+  source.SetAttribute ("MaxBytes", UintegerValue (0));
+  ApplicationContainer sourceApps = source.Install (sender.Get (0));
+  sourceApps.Start (Seconds (0.0));
+  Simulator::Schedule (Seconds (0.2), &TraceCwnd, 0, 0);
+  sourceApps.Stop (stopTime);
+
+  // Install application on the receiver
+  PacketSinkHelper sink ("ns3::TcpSocketFactory", InetSocketAddress (Ipv4Address::GetAny (), port));
+  ApplicationContainer sinkApps = sink.Install (receiver.Get (0));
+  sinkApps.Start (Seconds (0.0));
+  sinkApps.Stop (stopTime);
+
+  // Create a new directory to store the output of the program
+  dir = "bbr-results/" + currentTime + "/";
+  std::string dirToSave = "mkdir -p " + dir;
+  if (system (dirToSave.c_str ()) == -1)
+    {
+      exit (1);
+    }
+
+  // The plotting scripts are provided in the following repository, if needed:
+  // https://github.com/mohittahiliani/BBR-Validation/
+  //
+  // Download 'PlotScripts' directory (which is inside ns-3 scripts directory)
+  // from the link given above and place it in the ns-3 root directory.
+  // Uncomment the following three lines to generate plots for Congestion
+  // Window, sender side throughput and queue occupancy on the bottleneck link.
+  //
+  // system (("cp -R PlotScripts/gnuplotScriptCwnd " + dir).c_str ());
+  // system (("cp -R PlotScripts/gnuplotScriptThroughput " + dir).c_str ());
+  // system (("cp -R PlotScripts/gnuplotScriptQueueSize " + dir).c_str ());
+
+  // Trace the queue occupancy on the second interface of R1
+  tch.Uninstall (routers.Get (0)->GetDevice (1));
+  QueueDiscContainer qd;
+  qd = tch.Install (routers.Get (0)->GetDevice (1));
+  Simulator::ScheduleNow (&CheckQueueSize, qd.Get (0));
+
+  // Generate PCAP traces if it is enabled
+  if (enablePcap)
+    {
+      if (system ((dirToSave + "/pcap/").c_str ()) == -1)
+        {
+          exit (1);
+        }
+      bottleneckLink.EnablePcapAll (dir + "/pcap/bbr", true);
+    }
+
+  // Check for dropped packets using Flow Monitor
+  FlowMonitorHelper flowmon;
+  Ptr<FlowMonitor> monitor = flowmon.InstallAll ();
+  Simulator::Schedule (Seconds (0 + 0.000001), &TraceThroughput, monitor);
+
+  Simulator::Stop (stopTime + TimeStep (1));
+  Simulator::Run ();
+  Simulator::Destroy ();
+
+  return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/tcp/tcp-pacing.cc ns-3.34/examples/tcp/tcp-pacing.cc
--- ns-3.33/examples/tcp/tcp-pacing.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/tcp/tcp-pacing.cc	2021-07-14 10:31:06.000000000 -0700
@@ -148,7 +148,7 @@
   bool tracing = false;
 
   uint32_t maxBytes = 0; // value of zero corresponds to unlimited send
-  std::string transportProtocol = "ns3::TcpNewReno";
+  std::string transportProtocol = "ns3::TcpCubic";
 
   Time simulationEndTime = Seconds (5);
   DataRate bottleneckBandwidth ("10Mbps");  // value of x as shown in the above network topology
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/tcp/tcp-variants-comparison.cc ns-3.34/examples/tcp/tcp-variants-comparison.cc
--- ns-3.33/examples/tcp/tcp-variants-comparison.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/tcp/tcp-variants-comparison.cc	2021-07-14 10:31:06.000000000 -0700
@@ -230,7 +230,7 @@
   cmd.AddValue ("transport_prot", "Transport protocol to use: TcpNewReno, TcpLinuxReno, "
                 "TcpHybla, TcpHighSpeed, TcpHtcp, TcpVegas, TcpScalable, TcpVeno, "
                 "TcpBic, TcpYeah, TcpIllinois, TcpWestwood, TcpWestwoodPlus, TcpLedbat, "
-		"TcpLp, TcpDctcp, TcpCubic", transport_prot);
+		"TcpLp, TcpDctcp, TcpCubic, TcpBbr", transport_prot);
   cmd.AddValue ("error_p", "Packet error rate", error_p);
   cmd.AddValue ("bandwidth", "Bottleneck bandwidth", bandwidth);
   cmd.AddValue ("delay", "Bottleneck delay", delay);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/tcp/wscript ns-3.34/examples/tcp/wscript
--- ns-3.33/examples/tcp/wscript	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/tcp/wscript	2021-07-14 10:31:06.000000000 -0700
@@ -57,3 +57,8 @@
                                  ['point-to-point', 'internet', 'applications', 'traffic-control', 'network', 'internet-apps'])
 
     obj.source = 'tcp-validation.cc'
+
+    obj = bld.create_ns3_program('tcp-bbr-example',
+                                 ['point-to-point', 'internet', 'applications', 'traffic-control', 'network', 'internet-apps', 'flow-monitor'])
+
+    obj.source = 'tcp-bbr-example.cc'
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/tutorial/third.cc ns-3.34/examples/tutorial/third.cc
--- ns-3.33/examples/tutorial/third.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/tutorial/third.cc	2021-07-14 10:31:06.000000000 -0700
@@ -173,8 +173,9 @@
 
   Simulator::Stop (Seconds (10.0));
 
-  if (tracing == true)
+  if (tracing)
     {
+      phy.SetPcapDataLinkType (WifiPhyHelper::DLT_IEEE802_11_RADIO);
       pointToPoint.EnablePcapAll ("third");
       phy.EnablePcap ("third", apDevices.Get (0));
       csma.EnablePcap ("third", csmaDevices.Get (0), true);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/tutorial/third.py ns-3.34/examples/tutorial/third.py
--- ns-3.33/examples/tutorial/third.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/tutorial/third.py	2021-07-14 10:31:06.000000000 -0700
@@ -90,7 +90,7 @@
 wifiApNode = p2pNodes.Get(0)
 
 channel = ns.wifi.YansWifiChannelHelper.Default()
-phy = ns.wifi.YansWifiPhyHelper.Default()
+phy = ns.wifi.YansWifiPhyHelper()
 phy.SetChannel(channel.Create())
 
 wifi = ns.wifi.WifiHelper()
@@ -152,6 +152,7 @@
 ns.core.Simulator.Stop(ns.core.Seconds(10.0))
 
 if tracing == "True":
+	phy.SetPcapDataLinkType(phy.DLT_IEEE802_11_RADIO)
 	pointToPoint.EnablePcapAll ("third")
 	phy.EnablePcap ("third", apDevices.Get (0))
 	csma.EnablePcap ("third", csmaDevices.Get (0), True)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/udp-client-server/udp-client-server.cc ns-3.34/examples/udp-client-server/udp-client-server.cc
--- ns-3.33/examples/udp-client-server/udp-client-server.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/udp-client-server/udp-client-server.cc	2021-07-14 10:31:06.000000000 -0700
@@ -1,5 +1,7 @@
 /* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
 /*
+ * Copyright (c) 2009 INRIA
+ *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation;
@@ -12,6 +14,8 @@
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mohamed Amine Ismail <amine.ismail@sophia.inria.fr>
  */
 
 // Network topology
@@ -19,9 +23,12 @@
 //       n0    n1
 //       |     |
 //       =======
-//         LAN
+//         LAN (CSMA)
 //
-// - UDP flows from n0 to n1
+// - UDP flow from n0 to n1 of 1024 byte packets at intervals of 50 ms
+//   - maximum of 320 packets sent (or limited by simulation duration)
+//   - option to use IPv4 or IPv6 addressing
+//   - option to disable logging statements
 
 #include <fstream>
 #include "ns3/core-module.h"
@@ -36,42 +43,36 @@
 int
 main (int argc, char *argv[])
 {
-//
-// Enable logging for UdpClient and
-//
-  LogComponentEnable ("UdpClient", LOG_LEVEL_INFO);
-  LogComponentEnable ("UdpServer", LOG_LEVEL_INFO);
-
+  // Declare variables used in command-line arguments
   bool useV6 = false;
+  bool logging = true;
   Address serverAddress;
 
   CommandLine cmd (__FILE__);
   cmd.AddValue ("useIpv6", "Use Ipv6", useV6);
+  cmd.AddValue ("logging", "Enable logging", logging);
   cmd.Parse (argc, argv);
 
-//
-// Explicitly create the nodes required by the topology (shown above).
-//
-  NS_LOG_INFO ("Create nodes.");
+  if (logging)
+    {
+      LogComponentEnable ("UdpClient", LOG_LEVEL_INFO);
+      LogComponentEnable ("UdpServer", LOG_LEVEL_INFO);
+    }
+
+  NS_LOG_INFO ("Create nodes in above topology.");
   NodeContainer n;
   n.Create (2);
 
   InternetStackHelper internet;
   internet.Install (n);
 
-  NS_LOG_INFO ("Create channels.");
-//
-// Explicitly create the channels required by the topology (shown above).
-//
+  NS_LOG_INFO ("Create channel between the two nodes.");
   CsmaHelper csma;
   csma.SetChannelAttribute ("DataRate", DataRateValue (DataRate (5000000)));
   csma.SetChannelAttribute ("Delay", TimeValue (MilliSeconds (2)));
   csma.SetDeviceAttribute ("Mtu", UintegerValue (1400));
   NetDeviceContainer d = csma.Install (n);
 
-//
-// We've got the "hardware" in place.  Now we need to add IP addresses.
-//
   NS_LOG_INFO ("Assign IP Addresses.");
   if (useV6 == false)
     {
@@ -88,20 +89,14 @@
       serverAddress = Address(i6.GetAddress (1,1));
     }
 
-  NS_LOG_INFO ("Create Applications.");
-//
-// Create one udpServer applications on node one.
-//
+  NS_LOG_INFO ("Create UdpServer application on node 1.");
   uint16_t port = 4000;
   UdpServerHelper server (port);
   ApplicationContainer apps = server.Install (n.Get (1));
   apps.Start (Seconds (1.0));
   apps.Stop (Seconds (10.0));
 
-//
-// Create one UdpClient application to send UDP datagrams from node zero to
-// node one.
-//
+  NS_LOG_INFO ("Create UdpClient application on node 0 to send to node 1.");
   uint32_t MaxPacketSize = 1024;
   Time interPacketInterval = Seconds (0.05);
   uint32_t maxPacketCount = 320;
@@ -113,9 +108,6 @@
   apps.Start (Seconds (2.0));
   apps.Stop (Seconds (10.0));
 
-//
-// Now, do the actual simulation.
-//
   NS_LOG_INFO ("Run Simulation.");
   Simulator::Run ();
   Simulator::Destroy ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/udp-client-server/udp-trace-client-server.cc ns-3.34/examples/udp-client-server/udp-trace-client-server.cc
--- ns-3.33/examples/udp-client-server/udp-trace-client-server.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/udp-client-server/udp-trace-client-server.cc	2021-07-14 10:31:06.000000000 -0700
@@ -1,5 +1,7 @@
 /* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
 /*
+ * Copyright (c) 2009 INRIA
+ *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation;
@@ -12,6 +14,8 @@
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mohamed Amine Ismail <amine.ismail@sophia.inria.fr>
  */
 
 // Network topology
@@ -19,9 +23,11 @@
 //       n0    n1
 //       |     |
 //       =======
-//         LAN
+//         LAN (CSMA)
 //
-// - UDP flows from n0 to n1
+// - UDP flow from n0 to n1 of packets drawn from a trace file
+//  -- option to use IPv4 or IPv6 addressing
+//  -- option to disable logging statements
 
 #include <fstream>
 #include "ns3/core-module.h"
@@ -36,42 +42,36 @@
 int
 main (int argc, char *argv[])
 {
-//
-// Enable logging for UdpClient and
-//
-  LogComponentEnable ("UdpTraceClient", LOG_LEVEL_INFO);
-  LogComponentEnable ("UdpServer", LOG_LEVEL_INFO);
-
+  // Declare variables used in command-line arguments
   bool useV6 = false;
+  bool logging = true;
   Address serverAddress;
 
   CommandLine cmd (__FILE__);
   cmd.AddValue ("useIpv6", "Use Ipv6", useV6);
+  cmd.AddValue ("logging", "Enable logging", logging);
   cmd.Parse (argc, argv);
 
-//
-// Explicitly create the nodes required by the topology (shown above).
-//
-  NS_LOG_INFO ("Create nodes.");
+  if (logging)
+    {
+      LogComponentEnable ("UdpClient", LOG_LEVEL_INFO);
+      LogComponentEnable ("UdpServer", LOG_LEVEL_INFO);
+    }
+
+  NS_LOG_INFO ("Create nodes in above topology.");
   NodeContainer n;
   n.Create (2);
 
   InternetStackHelper internet;
   internet.Install (n);
 
-  NS_LOG_INFO ("Create channels.");
-//
-// Explicitly create the channels required by the topology (shown above).
-//
+  NS_LOG_INFO ("Create channel between the two nodes.");
   CsmaHelper csma;
   csma.SetChannelAttribute ("DataRate", DataRateValue (DataRate (5000000)));
   csma.SetChannelAttribute ("Delay", TimeValue (MilliSeconds (2)));
   csma.SetDeviceAttribute ("Mtu", UintegerValue (1500));
   NetDeviceContainer d = csma.Install (n);
 
-//
-// We've got the "hardware" in place.  Now we need to add IP addresses.
-//
   NS_LOG_INFO ("Assign IP Addresses.");
   if (useV6 == false)
     {
@@ -88,20 +88,14 @@
       serverAddress = Address(i6.GetAddress (1,1));
     }
 
-  NS_LOG_INFO ("Create Applications.");
-//
-// Create one udpServer applications on node one.
-//
+  NS_LOG_INFO ("Create UdpServer application on node 1.");
   uint16_t port = 4000;
   UdpServerHelper server (port);
   ApplicationContainer apps = server.Install (n.Get (1));
   apps.Start (Seconds (1.0));
   apps.Stop (Seconds (10.0));
 
-//
-// Create one UdpTraceClient application to send UDP datagrams from node zero to
-// node one.
-//
+  NS_LOG_INFO ("Create UdpClient application on node 0 to send to node 1.");
   uint32_t MaxPacketSize = 1472;  // Back off 20 (IP) + 8 (UDP) bytes from MTU
   UdpTraceClientHelper client (serverAddress, port,"");
   client.SetAttribute ("MaxPacketSize", UintegerValue (MaxPacketSize));
@@ -109,9 +103,6 @@
   apps.Start (Seconds (2.0));
   apps.Stop (Seconds (10.0));
 
-//
-// Now, do the actual simulation.
-//
   NS_LOG_INFO ("Run Simulation.");
   Simulator::Run ();
   Simulator::Destroy ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/examples-to-run.py ns-3.34/examples/wireless/examples-to-run.py
--- ns-3.33/examples/wireless/examples-to-run.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/examples-to-run.py	2021-07-14 10:31:06.000000000 -0700
@@ -50,16 +50,13 @@
     ("wifi-he-network --simulationTime=0.25 --frequency=2.4 --useRts=0 --minExpectedThroughput=6 --maxExpectedThroughput=238", "True", "True"),
     ("wifi-he-network --simulationTime=0.3 --frequency=2.4 --useRts=1 --minExpectedThroughput=6 --maxExpectedThroughput=223", "True", "True"),
     ("wifi-simple-ht-hidden-stations --simulationTime=1 --enableRts=0 --nMpdus=32 --minExpectedThroughput=59 --maxExpectedThroughput=60", "True", "True"),
-    ("wifi-simple-ht-hidden-stations --simulationTime=1 --enableRts=1 --nMpdus=32 --minExpectedThroughput=56 --maxExpectedThroughput=57", "True", "True"),
+    ("wifi-simple-ht-hidden-stations --simulationTime=1 --enableRts=1 --nMpdus=32 --minExpectedThroughput=57 --maxExpectedThroughput=58", "True", "True"),
     ("wifi-mixed-network --simulationTime=1", "True", "True"),
     ("wifi-aggregation --simulationTime=1 --verifyResults=1", "True", "True"),
     ("wifi-txop-aggregation --simulationTime=1 --verifyResults=1", "True", "True"),
     ("wifi-80211e-txop --simulationTime=1 --verifyResults=1", "True", "True"),
     ("wifi-multi-tos --simulationTime=1 --nWifi=16 --useRts=1 --useShortGuardInterval=1", "True", "True"),
     ("wifi-tcp", "True", "True"),
-    ("wifi-pcf --simulationTime=1 --withData=0", "True", "True"),
-    ("wifi-pcf --simulationTime=1 --withData=1 --trafficDirection=upstream", "True", "True"),
-    ("wifi-pcf --simulationTime=1 --withData=1 --trafficDirection=downstream", "True", "True"),
     ("wifi-hidden-terminal --wifiManager=Arf", "True", "True"),
     ("wifi-hidden-terminal --wifiManager=Aarf", "True", "True"),
     ("wifi-hidden-terminal --wifiManager=Aarfcd", "True", "True"),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/mixed-wired-wireless.cc ns-3.34/examples/wireless/mixed-wired-wireless.cc
--- ns-3.33/examples/wireless/mixed-wired-wireless.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/mixed-wired-wireless.cc	2021-07-14 10:31:06.000000000 -0700
@@ -156,6 +156,7 @@
   wifi.SetRemoteStationManager ("ns3::ConstantRateWifiManager",
                                 "DataMode", StringValue ("OfdmRate54Mbps"));
   YansWifiPhyHelper wifiPhy;
+  wifiPhy.SetPcapDataLinkType (WifiPhyHelper::DLT_IEEE802_11_RADIO);
   YansWifiChannelHelper wifiChannel = YansWifiChannelHelper::Default ();
   wifiPhy.SetChannel (wifiChannel.Create ());
   NetDeviceContainer backboneDevices = wifi.Install (wifiPhy, mac, backbone);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/mixed-wired-wireless.py ns-3.34/examples/wireless/mixed-wired-wireless.py
--- ns-3.33/examples/wireless/mixed-wired-wireless.py	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/mixed-wired-wireless.py	2021-07-14 10:31:06.000000000 -0700
@@ -136,6 +136,7 @@
     wifi.SetRemoteStationManager("ns3::ConstantRateWifiManager",
                                   "DataMode", ns.core.StringValue("OfdmRate54Mbps"))
     wifiPhy = ns.wifi.YansWifiPhyHelper()
+    wifiPhy.SetPcapDataLinkType(wifiPhy.DLT_IEEE802_11_RADIO)
     wifiChannel = ns.wifi.YansWifiChannelHelper.Default()
     wifiPhy.SetChannel(wifiChannel.Create())
     backboneDevices = wifi.Install(wifiPhy, mac, backbone)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/wifi-80211e-txop.cc ns-3.34/examples/wireless/wifi-80211e-txop.cc
--- ns-3.33/examples/wireless/wifi-80211e-txop.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/wifi-80211e-txop.cc	2021-07-14 10:31:06.000000000 -0700
@@ -372,7 +372,7 @@
   throughput = totalPacketsThroughB * payloadSize * 8 / (simulationTime * 1000000.0);
   std::cout << "AC_BE with non-default TXOP limit (3.008ms): " << '\n'
             << "  Throughput = " << throughput << " Mbit/s" << '\n';
-  if (verifyResults && (throughput < 35.5 || throughput > 36.5))
+  if (verifyResults && (throughput < 35 || throughput > 36))
     {
       NS_LOG_ERROR ("Obtained throughput " << throughput << " is not in the expected boundaries!");
       exit (1);
@@ -387,7 +387,7 @@
   throughput = totalPacketsThroughC * payloadSize * 8 / (simulationTime * 1000000.0);
   std::cout << "AC_VI with default TXOP limit (3.008ms): " << '\n'
             << "  Throughput = " << throughput << " Mbit/s" << '\n';
-  if (verifyResults && (throughput < 36 || throughput > 37))
+  if (verifyResults && (throughput < 35 || throughput > 36))
     {
       NS_LOG_ERROR ("Obtained throughput " << throughput << " is not in the expected boundaries!");
       exit (1);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/wifi-adhoc.cc ns-3.34/examples/wireless/wifi-adhoc.cc
--- ns-3.33/examples/wireless/wifi-adhoc.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/wifi-adhoc.cc	2021-07-14 10:31:06.000000000 -0700
@@ -241,7 +241,6 @@
   gnuplot.GenerateOutput (std::cout);
 
   gnuplot = Gnuplot ("rate-control.png");
-  wifi.SetStandard (WIFI_STANDARD_holland);
 
   NS_LOG_DEBUG ("arf");
   experiment = Experiment ("arf");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/wifi-backward-compatibility.cc ns-3.34/examples/wireless/wifi-backward-compatibility.cc
--- ns-3.33/examples/wireless/wifi-backward-compatibility.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/wifi-backward-compatibility.cc	2021-07-14 10:31:06.000000000 -0700
@@ -21,6 +21,7 @@
 #include "ns3/command-line.h"
 #include "ns3/config.h"
 #include "ns3/uinteger.h"
+#include "ns3/boolean.h"
 #include "ns3/log.h"
 #include "ns3/yans-wifi-helper.h"
 #include "ns3/ssid.h"
@@ -66,10 +67,6 @@
     {
       standard = WIFI_STANDARD_80211p;
     }
-  else if (version == "holland")
-    {
-      standard = WIFI_STANDARD_holland;
-    }
   else if (version == "80211n_2_4GHZ")
     {
       standard = WIFI_STANDARD_80211n_2_4GHZ;
@@ -106,8 +103,8 @@
 
   CommandLine cmd (__FILE__);
   cmd.AddValue ("simulationTime", "Simulation time in seconds", simulationTime);
-  cmd.AddValue ("apVersion", "The standard version used by the AP: 80211a, 80211b, 80211g, 80211p, holland, 80211n_2_4GHZ, 80211n_5GHZ, 80211ac, 80211ax_2_4GHZ or 80211ax_5GHZ", apVersion);
-  cmd.AddValue ("staVersion", "The standard version used by the station: 80211a, 80211b, 80211g, 80211_10MHZ, 80211_5MHZ, holland, 80211n_2_4GHZ, 80211n_5GHZ, 80211ac, 80211ax_2_4GHZ or 80211ax_5GHZ", staVersion);
+  cmd.AddValue ("apVersion", "The standard version used by the AP: 80211a, 80211b, 80211g, 80211p, 80211n_2_4GHZ, 80211n_5GHZ, 80211ac, 80211ax_2_4GHZ or 80211ax_5GHZ", apVersion);
+  cmd.AddValue ("staVersion", "The standard version used by the station: 80211a, 80211b, 80211g, 80211_10MHZ, 80211_5MHZ, 80211n_2_4GHZ, 80211n_5GHZ, 80211ac, 80211ax_2_4GHZ or 80211ax_5GHZ", staVersion);
   cmd.AddValue ("apRaa", "Rate adaptation algorithm used by the AP", apRaa);
   cmd.AddValue ("staRaa", "Rate adaptation algorithm used by the station", staRaa);
   cmd.AddValue ("apHasTraffic", "Enable/disable traffic on the AP", apHasTraffic);
@@ -131,8 +128,16 @@
   wifi.SetRemoteStationManager ("ns3::" + staRaa + "WifiManager");
 
   mac.SetType ("ns3::StaWifiMac",
+               "QosSupported", BooleanValue (true),
                "Ssid", SsidValue (ssid));
 
+  //Workaround needed as long as we do not fully support channel bonding
+  if (staVersion == "80211ac")
+    {
+      phy.Set ("ChannelWidth", UintegerValue (20));
+      phy.Set ("Frequency", UintegerValue (5180));
+    }
+
   NetDeviceContainer staDevice;
   staDevice = wifi.Install (phy, mac, wifiStaNode);
 
@@ -140,23 +145,19 @@
   wifi.SetRemoteStationManager ("ns3::" + apRaa + "WifiManager");
 
   mac.SetType ("ns3::ApWifiMac",
+               "QosSupported", BooleanValue (true),
                "Ssid", SsidValue (ssid));
 
-  NetDeviceContainer apDevice;
-  apDevice = wifi.Install (phy, mac, wifiApNode);
-
   //Workaround needed as long as we do not fully support channel bonding
-  if (staVersion == "80211ac")
-    {
-      Config::Set ("/NodeList/0/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelWidth", UintegerValue (20));
-      Config::Set ("/NodeList/0/DeviceList/*/$ns3::WifiNetDevice/Phy/Frequency", UintegerValue (5180));
-    }
   if (apVersion == "80211ac")
     {
-      Config::Set ("/NodeList/1/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelWidth", UintegerValue (20));
-      Config::Set ("/NodeList/1/DeviceList/*/$ns3::WifiNetDevice/Phy/Frequency", UintegerValue (5180));
+      phy.Set ("ChannelWidth", UintegerValue (20));
+      phy.Set ("Frequency", UintegerValue (5180));
     }
 
+  NetDeviceContainer apDevice;
+  apDevice = wifi.Install (phy, mac, wifiApNode);
+
   MobilityHelper mobility;
   Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator> ();
   positionAlloc->Add (Vector (0.0, 0.0, 0.0));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/examples/wireless/wifi-blockack.cc ns-3.34/examples/wireless/wifi-blockack.cc
--- ns-3.33/examples/wireless/wifi-blockack.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/examples/wireless/wifi-blockack.cc	2021-07-14 10:31:06.000000000 -0700
@@ -74,6 +74,7 @@
 
   YansWifiChannelHelper channel = YansWifiChannelHelper::Default ();
   YansWifiPhyHelper phy;
+  phy.SetPcapDataLinkType (WifiPhyHelper::DLT_IEEE802_11_RADIO);
   phy.SetChannel (channel.Create ());
 
   WifiHelper wifi;
